pipeline { 
    agent any  
   tools {
        "org.jenkinsci.plugins.terraform.TerraformInstallation" "terraform"
    }
  environment {
        TF_HOME = tool('terraform')
        TF_IN_AUTOMATION = "true"
        PATH = "$TF_HOME:$PATH"
    }
  stages {
    
        stage('Terraform Init'){
            
            steps {
                    
                    withCredentials([azureServicePrincipal(
                    credentialsId: 'jenkinsazuresp',
                    subscriptionIdVariable: 'ARM_SUBSCRIPTION_ID',
                    clientIdVariable: 'ARM_CLIENT_ID',
                    clientSecretVariable: 'ARM_CLIENT_SECRET',
                        tenantIdVariable: 'ARM_TENANT_ID')]){
                    sh 'terraform init' 
                    }
                          
             
        }
}
      
     
        stage('Terraform plan'){
            
            steps {
                    
                    withCredentials([azureServicePrincipal(
                    credentialsId: 'jenkinsazuresp',
                    subscriptionIdVariable: 'ARM_SUBSCRIPTION_ID',
                    clientIdVariable: 'ARM_CLIENT_ID',
                    clientSecretVariable: 'ARM_CLIENT_SECRET',
                        tenantIdVariable: 'ARM_TENANT_ID')]){
                    sh 'terraform plan' 
                    }
                          
             
        }
}
              stage('Terraform apply'){
            
            steps {
                    
                    withCredentials([azureServicePrincipal(
                    credentialsId: 'jenkinsazuresp',
                    subscriptionIdVariable: 'ARM_SUBSCRIPTION_ID',
                    clientIdVariable: 'ARM_CLIENT_ID',
                    clientSecretVariable: 'ARM_CLIENT_SECRET',
                        tenantIdVariable: 'ARM_TENANT_ID')]){
                    sh 'terraform apply --auto-approve' 
                    }
                          
             
        }
}
}
}
                        
